/* stanpump header file */
#ifndef TRUE
#define TRUE            1
#endif

#ifndef FALSE
#define FALSE           0
#endif

extern char subject[80];
extern char user[80];
extern unsigned int com_address[];
extern FILE *com_fd;
extern int debug_flag;
extern int showio_flag;
extern char *revision_date;
extern long force_end;
extern int pump_type;
extern char _far *pump_name[];
extern double pump_precision[];
extern double pump_rate_in_mls;
extern int started_flag;
extern int atx;
extern int aty;
extern int delta_seconds;
extern long seconds;
extern long reference_time;
extern long prior_infuse_time;
extern long prior_absolute_time;
extern long time_ahead;
extern long infuse_time;
extern int peak_time;
extern int prior_peak_time;
extern unsigned int com_port;
extern int reproduce_flag;
extern FILE *reproduce_file;
extern int track_flag;
extern FILE *track_file;
extern char track_filename[80];
extern long track_time;
extern int drg_flag;
extern FILE *drg_input_file;
extern char drg_input_filename[80];
extern long drg_time;
extern double reproduce_rate;
extern double reproduce_volume;
extern char reproduce_filename[80];
void reproduce_old_run();
extern double prior_pump_volume;
extern int bard_flag;
extern int seed;

extern int drug_id;
extern int kinetic_set;
extern int max_drug_id;
extern char *drug_name[];
extern char external_file_name[64];

extern char parameter_name[80];
extern int syringe_type;
extern char *syringe_name[];
extern double syringe_diameter[];
extern int max_syringe_volume[];
extern double syringe_volume;
extern double prior_syringes;
extern double minimum_syringe_volume;
extern double syringe_warning_volume;
extern int one_syringe_type;
extern int comm_status;
extern int pump_status;
extern int sys_status;
extern int warning;
extern int stalled_flag;
extern int run_flag;
extern int purge_flag;
extern int transport_flag;
extern int effect_flag;
extern int effect_data;
extern int gibbs_flag;
extern int propofol_study_flag;
extern int nausea_study_flag;
extern int lorazepam_study_flag;
extern int zero_order_flag;
extern int heart_failure;
extern double virtual_icu_drug;
extern double virtual_real_sum;


extern double mass;
extern double age;
extern int gender;
extern double height;
extern double bsa;
extern double lbm;
extern int scaled_mass_flag;
extern double desired;
extern double desired_effect;
extern double infusate_concentration;
extern double amount_infused;
extern double prior_reported_volume_infused;
extern double prior_working_volume_infused;
extern double maximum_rate;
extern double minimum_rate;
extern char species[15];
extern char conc_units[10];
extern char infused_units[10];
extern double vc;
extern double ve;
extern double k10;
extern double k12;
extern double k13;
extern double k21;
extern double k31;
extern double k14;
extern double k41;
extern double t_peak;
extern double cl1;
extern double k;
extern double e0;
extern double emax;
extern double ic50;
extern double ic50_gamma;
extern double gamma;
extern int pd_data;
extern char effect_text[80];
extern char effect_units[20];
extern double max_effect;
extern double max_concentration;
extern double awake_concentration;
extern int sim_speed;
extern long slow_sim;
extern int hudson_flag;
extern double ref_con;
extern FILE *pumpfile;
extern FILE *drgfile;
extern FILE *errorfile;
extern char output_file[30];
extern char kinetic_file[64];
extern long next_time;
extern char C2_address[10];
extern int C2_sim_flag;
extern double compression_factor;
extern double p_state[5];
extern double e_state[5];
extern double p_coef[5];
extern double e_coef[5];
extern double lambda[5];
extern int prior_flag;
extern int delete_flag;
extern int quick_flag;

int enter_key();
double enter_real();
double set_delta_error();
double read_volume_infused();

int read_C2_status();
int check_C2();
char *write_C2();
char *write_C2_sub();
char *write_harvard_22();
char *write_harvard_22_sub();
int check_harvard_22();
int read_to_end();
char write_port();
char read_port();
char *frame();
char *calc_crc();
long absolute_clock();
long relative_clock();
double pd_model();
double inverse_pd_model();

void fentanyl();
void alfentanil();
void sufentanil();
void dexmedetomidine();
void thiopental();
void midazolam();
void diazepam();
void propofol();
void lidocaine();
void ketamine();
void methohexital();
void etomidate();
void external();

/* Make PC-Lint Happy */
void main();
void start();
void terminate();
void infuse();
void display_pump_status();
void display_init();
void init_totals_display();
void display_awake();
void display_prompts();
void clear_prompt_area();
void display_update();
void display_time();
void display_desired();
void display_rate();
void gotoxy();
void cls();
void setup_port();
void initialize_globals();
void swap();
void purge_harvard_22();
void write_rate();
void initialize_pump();
void check_pump_status();
void get_syringe_size();
void calculate_udfs();
void main_loop();
void hudson_study();
